/*
    This file is part of the CLib sub-project of the FreeDOS project
    Copyright (C) 1997 by the author see below

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
/* $RCSfile: MEMRCHR.C $
   $Locker:  $	$Name:  $	$State: Exp $

	void *memrchr(void *s, int ch, size_t length)

	Search the last character within a memory area of length bytes.

	Input:
		s != NULL

	Return:
		NULL if ch is not found
		pointer to last appearance, otherwise

	Note:
		length is treated unsigned

	Conforms to:
		<none>

	See also:
		strrchr

	Target compilers:
		Any C compiler

	Origin:
		1997/10/10 Steffen Kaiser (ska)

	Revised by:
		<none>

	File Revision:    Revision 1.2  1998/02/08 04:55:59  ska
*/

#include <_clib.h>			/* standard include, must be the first! */
#include <_string.h>

#ifdef RCS_Version
static char const rcsid[] = 
	"$Id: MEMRCHR.C 1.2 1998/02/08 04:55:59 ska Exp $";
#endif

_CLibFunc void ___PTR *memrchr(void const ___PTR * const s
 , const int ch, REG size_t length)
{	REG uchar_t ___PTR *p;

	assert(s != NULL);

	p = (uchar_t ___PTR *)s + length;
	while(--p >= s)
		if(*p == (uchar_t)ch)
			return p;

	return NULL;
}
