#ifndef _h_HEAPSTACK_
#define _h_HEAPSTACK_

#ifndef _h_CPPHELP_
# include <cv/cpphelp.h>
#endif
#ifndef _h_STRING_
# include <cv/string.h>
#endif


class HeapStack;


/*---------------------------------------------------------*/
class HeapStack{
	NoCopy(HeapStack)
	NoAssignment(HeapStack)
public:
	struct pos{
		void	*block;
		size_t	dsize, avail, used, lost;
	};
	struct Info{
		count	blkcnt;
		size_t	used, lost, avail;
	};

	HeapStack()	{ p.block = NULL; p.avail = p.used = p.lost = 0; }
	~HeapStack()	{ release(); }

	void* SMALL_	alloc(size_t sz);
	PStr SMALL_	dup(charSeq);

	void		mark(pos &m)		{ m = p; }
	void SMALL_	release(const pos&);
	void SMALL_	release();
	void SMALL_	getInfo(Info&);
private:
	pos	p;
}; /* HeapStack */

#endif /* _h_HEAPSTACK_ */
