#ifndef _h_STATES_
#define _h_STATES_

#ifndef _h_TYPES_
# include <cv/types.h>
#endif


class States;

#define Mask(state)	setBit(state)

#define StatesInherit(inheritedClass)				\
		enum{	_st_start_ = inheritedClass::_st_last_,
#define StatesDeclare(num, state)				\
			s_##state = _st_start_ + num,		\
			m_##state = Mask(s_##state),
#define StatesEnd(num)	_st_last_ = _st_start_ + num };


/*---------------------------------------------------------*/
class States{
public:
	States() :st(0) {}
	States(ulong mask) :st(mask) {}

	ulong	mask(ulong m)		{ return checkBitMask(st, m); }
	void	onMask(ulong mask)	{ st |= mask; }
	void	offMask(ulong mask)	{ st &= ~mask; }

	bool	state(count s)		{ return bool(checkBit(st, s)); }
	void	on(count state)		{ onMask(Mask(state)); }
	void	off(count state)	{ offMask(Mask(state)); }
protected:
	enum{ _st_start_ = 0, _st_last_ = 0 };
private:
	ulong	st;
}; /* States */

#endif /* _h_STATES_ */
