#ifndef _h_STRING2_
#define _h_STRING2_

#ifndef _h_STRING_
# include <cv/string.h>
#endif


/*----------------------------------------------------------------------*/
#define isLower(ch)	((ch) >= 'a' && (ch) <= 'z')
#define isUpper(ch)	((ch) >= 'A' && (ch) <= 'Z')
#define isAlpha(ch)	(isLower(ch) || isUpper(ch))

/* !!! Fast ASCII tolower/toupper !!! */
#define _lower(ch)	((ch) | 0x20)
#define _dolower(var)	((var) |= 0x20)
#define _upper(ch)	((ch) & ~0x20)
#define _doupper(var)	((var) &= ~0x20)

#define lower(ch)	(isUpper(ch) ? (ch) + (char)('a' - 'A') : (ch))
#define dolower(var)	{ if(isUpper(var)) (var) += (char)('a' - 'A'); }
#define upper(ch)	(isLower(ch) ? (ch) - (char)('a' - 'A') : (ch))
#define doupper(var)	{ if(isLower(var)) (var) -= (char)('a' - 'A'); }


/*----------------------------------------------------------------------*/
size_t SMALL_	memmatch(CVP, CVP, size_t);
size_t SMALL_	memdiff(CVP, CVP, size_t);
void *SMALL_	memcopy(void *dest, CVP src, size_t);

/*----------------------------------------------------------------------*/
size_t FAST_	memspan(CVP, size_t, char);
size_t FAST_	memrspan(CVP, size_t, char);
size_t FAST_	memcspan(CVP, size_t, char);
size_t FAST_	memrcspan(CVP, size_t, char);

inline size_t	memspan(charSeq seq, char ch)   { return memspan(seq, seq.len, ch); }
inline size_t	memrspan(charSeq seq, char ch)  { return memrspan(seq, seq.len, ch); }
inline size_t	memcspan(charSeq seq, char ch)  { return memcspan(seq, seq.len, ch); }
inline size_t	memrcspan(charSeq seq, char ch) { return memrcspan(seq, seq.len, ch); }

/*----------------------------------------------------------------------*/
size_t SMALL_	memspan(CVP, size_t, CVP, size_t);
size_t SMALL_	memrspan(CVP, size_t, CVP, size_t);
size_t SMALL_	memcspan(CVP, size_t, CVP, size_t);
size_t SMALL_	memrcspan(CVP, size_t, CVP, size_t);

inline size_t	memspan(charSeq seq, charSeq s)   { return memspan(seq, seq.len, s, s.len); }
inline size_t	memrspan(charSeq seq, charSeq s)  { return memrspan(seq, seq.len, s, s.len); }
inline size_t	memcspan(charSeq seq, charSeq s)  { return memcspan(seq, seq.len, s, s.len); }
inline size_t	memrcspan(charSeq seq, charSeq s) { return memrcspan(seq, seq.len, s, s.len); }

/*----------------------------------------------------------------------*/
size_t FAST_	checklen(CStr);
inline size_t	checklen(CStr s, size_t sz)	{ return memcspan(s, sz, EOS); }

String& SMALL_	reverse(String&);
inline void	rtrim(String &src, CStr sp)
			{ src.trunc(memrspan(src, src.len, sp, strlen(sp))); }
inline void	rtrim(String &src)
			{ src.trunc(memrspan(src, src.len, " \t", 2)); }

bool FAST_	wildcmp(PCStr mask, PCStr name);

#endif /* _h_STRING2_ */
