#include <cv/dos.h>
#include <cv/mouse.h>
#include <cv/screen.h>


//*** For speed up ***********************
#define present()	(buttonCount != 0)
//****************************************

static struct construct{ mouse m; construct() {} ~construct() {} } im;


static word near mask;
static FP_PROC handler = NULL;
byte near mouse::buttonCount = 0;

REGPACK r;

void mouse::resume(){
	if(getvect(0x33) == 0) return;
	r.r_ax = 0; intr(0x33, &r); if(r.r_ax == 0) return;

	buttonCount = loByte(r.r_bx);
	r.r_cx = 0; r.r_dx = 0; r.r_ax = 4; intr(0x33, &r);
	if(handler) registerHandler(mask, handler);
}

void mouse::suspend(){
	hide();
	if(handler) registerHandler(0, 0);
	buttonCount = 0;
}

void mouse::show(){ if(present()){ _AX = 1; geninterrupt(0x33); } }

void mouse::hide(){ if(present()){ _AX = 2; geninterrupt(0x33); } }

void mouse::hideIf(rect hole){
	if(!present()) return;
	hole.a.x -= 15; hole.a.y -= 15;
	r.r_ax = 3; intr(0x33, &r);
	if(hole.contains(r.r_cx, r.r_dx)) hide();
}

void mouse::hideArea(rect rc){
	if(!present()) return;
	r.r_cx = rc.a.x; r.r_dx = rc.a.y;
	r.r_si = rc.b.x; r.r_di = rc.b.y;
	r.r_ax = 16; intr(0x33, &r);
}

void mouse::restrict(rect rc){
	if(!present()) return;
	r.r_cx = rc.a.x; r.r_dx = rc.b.x; r.r_ax = 7; intr(0x33, &r);
	r.r_cx = rc.a.y; r.r_dx = rc.b.y; r.r_ax = 8; intr(0x33, &r);
}

void mouse::getEvent(mouseEvent &me){
	if(!present()) return;
	r.r_ax = 3; intr(0x33, &r);
	me.buttons = loByte(r.r_bx);
	me.where.x = r.r_cx;
	me.where.y = r.r_dx;
	me.doubleClick = false;
}

void mouse::registerHandler(word mask, FP_PROC func){
	if(!present()) return;
	r.r_ax = 20; r.r_cx = mask;
	r.r_dx = FP_OFF(func); r.r_es = FP_SEG(func);
	intr(0x33, &r);
}


//---------------------------------------------------------
#define ingraph	(_scrmode > smCO80 && _scrmode != smMono)

point txt2mou(int x, int y){
	point p;
	p.x = x * 8; if(scrwidth == 40) p.x <<= 1;	// x * 8 | 16
	p.y = ingraph ? (y * charheight) : (y * 8);
	return p;
}

point mou2txt(point p){
	p.x >>= 3; if(scrwidth == 40) p.x >>= 1;	// p.x /= 8 | 16
	if(ingraph) p.y /= charheight; else p.y >>= 3;
	return p;
}
